dim DefaultUnit

DefaultUnit = "English"   ' change this to metric if plan on using mostly metric units 
			  ' (so you don't have to double up on your cached files)

Function CityName(LocationID)
 CityName = GetXML(LocationID, "loc", "dnam", DefaultUnit)
End Function

Function CityDataAccurate(LocationID)
 CityDataAccurate = GetXML(LocationID, "cc", "obst", DefaultUnit)
End Function

Function Latitude(LocationID)
 Latitude = GetXML(LocationID, "loc", "lat", DefaultUnit)
End Function

Function Longitude(LocationID)
 Longitude = GetXML(LocationID, "loc", "lon", DefaultUnit)
End Function

Function LocalTime(LocationID)
 LocalTime = GetXML(LocationID, "loc", "tm", DefaultUnit)
End Function

Function Sunrise(LocationID)
 Sunrise = GetXML(LocationID, "loc", "sunr", DefaultUnit)
End Function

Function Sunset(LocationID)
 Sunset = GetXML(LocationID, "loc", "suns", DefaultUnit)
End Function

Function Temp(LocationID, UnitType, ShowUnit)
 If UnitType = "Both" Then
  Temp = Temp(LocationID, "English", 1) & "/" & Temp(LocationID, "Metric", 1)
 Else
  Temp = GetXML(LocationID, "cc", "tmp", UnitType) & "" & MaybeUnit(TempUnit(LocationID, UnitType), ShowUnit)
 End If
End Function

Function TempFeelsLike(LocationID, UnitType, ShowUnit)
 If UnitType = "Both" Then
  TempFeelsLike = TempFeelsLike(LocationID, "English", 1) & "/" & TempFeelsLike(LocationID, "Metric", 1)
 Else
 TempFeelsLike = GetXML(LocationID, "cc", "flik", UnitType) & "" & MaybeUnit(TempUnit(LocationID, UnitType), ShowUnit)
 End If
End Function

Function TempAndTempFeel(LocationID, UnitType, ShowUnit)
 If TempFeelsLike(LocationID, UnitType, ShowUnit) = "" OR TempFeelsLike(LocationID, UnitType, ShowUnit) = Temp(LocationID, UnitType, ShowUnit) then
  TempAndTempFeel = Temp(LocationID, UnitType, ShowUnit)
 else
  TempAndTempFeel = Temp(LocationID, UnitType, ShowUnit) & " (" & TempFeelsLike(LocationID, UnitType, ShowUnit) & ")"
 end if
End Function

Function Symbol(LocationID, PathToPNGs, ImageSize)
 If(mid(PathToPNGs, len(PathToPNGs), len(PathToPNGs)+1) <> "\") Then
  ThePath = PathToPNGs & "\"
 Else
  ThePath = PathToPNGs
 End If
 If ImageSize <> "small" AND ImageSize <> "medium" AND ImageSize <> "large" Then
  Symbol = "Set ImageSize to any of these values: small, medium, large"
  Exit Function
 End If
 Symbol = ThePath & ImageSize & GetXML(LocationID, "cc", "icon", DefaultUnit) & ".png"
End Function

Private Function TheDate(which)
 TheDate = Now()
 TheDate = Pattern(TheDate, "(.*?)/(.*?)/(.*?) (.*?)", which)
 TheDate = TheDate+0
End Function

Function Condition(LocationID)
 Condition = GetXML(LocationID, "cc", "t", DefaultUnit)
End Function

Function Humidity(LocationID)
 Humidity = GetXML(LocationID, "cc", "hmid", DefaultUnit)
End Function

Function WindSpeed(LocationID, UnitType, ShowUnit)
 WindSpeed = TheWindSpeed(LocationID, UnitType, ShowUnit, 0, "")
End Function

Function WindSpeedMetersPerSecond(LocationID, ShowUnit)
 WindSpeedMetersPerSecond = TheWindSpeed(LocationID, "Metric", ShowUnit, 3.6, "m/s")
End Function

Private Function TheWindSpeed(LocationID, UnitType, ShowUnit, Special, SpecialUnit)
 Gust = GetXML(LocationID, "wind", "gust", UnitType)
 If Gust = "N/A" Then
  Gust = " "
 Else
  If Special > 0 Then
   Gust = Round(Gust / Special, 0)
  End If
  Gust = " to " & Gust
 End If
 TheWindSpeed = GetXML(LocationID, "wind", "s", UnitType)
 If TheWindSpeed <> "calm" Then
  If Special > 0 Then
   TheWindSpeed = Round(TheWindSpeed / Special, 0) & Gust & MaybeUnit(SpecialUnit, ShowUnit)
  Else
   TheWindSpeed = TheWindSpeed & Gust & MaybeUnit(SpeedUnit(LocationID, UnitType), ShowUnit)
  End If
 End If
End Function

Function WindDirectionCardinal(LocationID)
 WindDirectionCardinal = GetXML(LocationID, "wind", "t", DefaultUnit)
 If WindDirectionCardinal = "CALM" then
  WindDirectionCardinal = "N/A"
 End If
End Function

Function WindDirectionDegrees(LocationID)
 WindDirectionDegrees = GetXML(LocationID, "wind", "d", DefaultUnit)
End Function

Function UVIndex(LocationID, ShowNumber, ShowDescription)
 UVNumber = GetXML(LocationID, "uv", "i", DefaultUnit)
 UVDescribe = GetXML(LocationID, "uv", "t", DefaultUnit)
 If ShowNumber <> 0 Then
  UVIndex = UVNumber
  If ShowDescription <> 0 Then
   UVIndex = UVIndex & " " & UVDescribe
  End If
 Else
  If ShowDescription <> 0 Then
   UVIndex = UVDescribe
  Else
   UVIndex = "you chose to show nothing"
  End If
 End If
End Function



Function DewPoint(LocationID, UnitType, ShowUnit)
 DewPoint = GetXML(LocationID, "cc", "dewp", UnitType) & "" & MaybeUnit(TempUnit(LocationID, UnitType), ShowUnit)
End Function

Function Visibility(LocationID, UnitType, ShowUnit)
 Visibility = GetXML(LocationID, "cc", "vis", UnitType)
 If Visibility <> "Unlimited" Then
  Visibility = Visibility & " " & MaybeUnit(DistUnit(LocationID, UnitType), ShowUnit)
 End If
End Function

Function BarometerValue(LocationID, UnitType, ShowUnit)
 BarometerValue = GetXML(LocationID, "bar", "r", UnitType) & " " & MaybeUnit(PressUnit(LocationID, UnitType), ShowUnit)
End Function

Function BarometerStatus(LocationID)
 BarometerStatus = GetXML(LocationID, "bar", "d", DefaultUnit)
End Function

Function UpdateTime(LocationID, ShowDate, ShowTime)
 UpdateTime = GetXML(LocationID, "cc", "lsup", DefaultUnit)
 theday = Pattern(UpdateTime, "(.*?)/(.*?)/(.*?) (.*?) (.*?) (.*?)", 1)
 themonth = Pattern(UpdateTime, "(.*?)/(.*?)/(.*?) (.*?) (.*?) (.*?)", 0)
 If ShowDate = "1" Then 
  TheDates = themonth & "/" & theday & " "
 Else
  TheDates = ""
 End If
 If ShowTime = "1" Then
  TheTime = Pattern(UpdateTime, "(.*?) (.*?) (.*?) (.*?)", 1) & " " & Pattern(UpdateTime, "(.*?) (.*?) (.*?) (.*?)", 2)
 Else
  TheTime = ""
 End If
 UpdateTime = TheDates & TheTime
End Function

Function UpdateTime24H(LocationID, ShowDate, ShowTime, DayBeforeMonth)
 UpdateTime24H = GetXML(LocationID, "cc", "lsup", DefaultUnit)
 theday = Pattern(UpdateTime24H, "(.*?)/(.*?)/(.*?) (.*?) (.*?) (.*?)", abs(DayBeforeMonth-1))
 themonth = Pattern(UpdateTime24H, "(.*?)/(.*?)/(.*?) (.*?) (.*?) (.*?)", DayBeforeMonth)
 If ShowDate = "1" Then 
  TheDates = themonth & "/" & theday & " "
 Else
  TheDates = ""
 End If
 If ShowTime = "1" Then
  TheTime = Pattern(UpdateTime24H, "(.*?) (.*?) (.*?) (.*?)", 1)
  TheHour = Pattern(TheTime, "(.*?):(.*?)", 0)
 ' TheTime = TheHour
  If Pattern(UpdateTime24H, "(.*?) (.*?) (.*?) (.*?)", 2) = "PM" AND TheHour<12 Then TheHour = TheHour + 12 End If
  TheTime = TheHour & ":" & Pattern(TheTime, "(.*?):(.*)", 1)

Else
  TheTime = ""
 End If
 UpdateTime24H = TheDates & TheTime
End Function

Private Function path(LocationID, Metric)
 path = GetTempPath & LocationID & "_" & Metric & ".tmp"
End Function

Private Function GetTempPath
 set fso=CreateObject("Scripting.FileSystemObject")
 GetTempPath = fso.GetSpecialFolder(2) & "\weather.com.forecast\" 
 if not fso.FolderExists(GetTempPath) then 
  fso.CreateFolder(GetTempPath)
 End if
End Function

Private Function TimeDiff(LocationID, Metric)
 dim fs,f,diff
 file = path(LocationID, Metric)
 set fs=CreateObject("Scripting.FileSystemObject")
 if fs.fileexists(file) then
  set f=fs.GetFile(file)
  diff = datediff( "n", f.DateLastModified, now())
 else
  diff = -1
 end if
 set f=nothing
 set fs=nothing
 TimeDiff = diff
End Function

Private Function GetXML(LocationID, TheParent, TheItem, UnitType)
 Dim fs,f,filename,FeedName,breakPoint
 Dim objXML,objLst,objHdl,TotalItems,title,tp
 Set objXML = CreateObject("Microsoft.XMLDOM")
 objXML.async = False
 objXML.LoadXML(GetText(LocationID, UnitType))
 If objXML.parseError.errorCode <> 0 Then
  GetXML = "Weather.com Data UNAVAILABLE"
  exit function
 End If
 GetXML = objXML.getElementsByTagName(TheParent).item(0).selectSingleNode("./" & TheItem).text
End Function

Private Function Pattern(TheString, ThePattern, MatchNum)
 Set regEx = New RegExp 
 regEx.Global = True
 regEx.IgnoreCase = True
 regEx.Pattern = ThePattern
 Set Matches = regEx.Execute(TheString) 
 For Each Match in Matches 
  result = trim(Match.SubMatches(MatchNum)) 
 Next 
 Pattern = result
End Function

Private Function RandomNum
 Randomize Timer
 RandomNum = Int(Rnd * 1000)
End Function

Private Function MaybeUnit(TheUnit, Maybe)
 If Maybe = 1 Then
  MaybeUnit = TheUnit
 Else
  MaybeUnit = ""
 End If
End Function

Private Function SetUnit(Metric)
 If Metric="Metric" Then
  SetUnit = "m"
 Else
  SetUnit = "s"
 End If
End Function

Private Function TempUnit(LocationID, Metric)
 TempUnit = GetXML(LocationID, "head", "ut", Metric)
End Function

Private Function DistUnit(LocationID, Metric)
 DistUnit = GetXML(LocationID, "head", "ud", Metric)
End Function

Private Function SpeedUnit(LocationID, Metric)
 SpeedUnit = GetXML(LocationID, "head", "us", Metric)
End Function

Private Function PressUnit(LocationID, Metric)
 PressUnit = GetXML(LocationID, "head", "up", Metric)
End Function

Private Function RainUnit(LocationID, Metric)
 RainUnit = GetXML(LocationID, "head", "ur", Metric)
End Function

Private Function GetText(LocationID, Metric)
 If TimeDiff(LocationID, Metric) < 0 Then
  GetText = Writefile(LocationID, Metric)       'file doesn't exist so fetch it
 Else
  If TimeDiff(LocationID, Metric) > 31 Then        'see if it needs refreshing
   GetText = Writefile(LocationID, Metric) 'refresh it
  End If
 End If
 GetText = GetFileContents(LocationID, Metric)           'read it's contents

End Function

Private Function GetFileContents(LocationID, Metric)
 Set file_obj = CreateObject ("Scripting.FileSystemObject")
 Set file_path = file_obj.GetFile(path(LocationID, Metric)) ' Creates the connection to the file
 set file = file_path.OpenAsTextStream (1, -2) ' Opens the file for reading
 GetFileContents = file.readall
 File.Close ' Closes the file
 Set file_path = nothing ' Resets variable
 Set file_obj = nothing ' Resets variable
End Function



Private Function Writefile(LocationID, Metric)
 GetURL = "http://xoap.weather.com/weather/local/" & LocationID & "?cc=*&unit=" & SetUnit(Metric) & "&" & RandomNum
 Dim Http
 Set Http = CreateObject("Microsoft.XMLhttp")
 Http.Open "GET",GetURL,False
 Http.Send
 HtmlResult = Http.ResponseText
 Set Http = Nothing
 Set fs=CreateObject("Scripting.FileSystemObject")
 If (fs.FileExists(path(LocationID, Metric))) Then
  Set aFile = fs.GetFile(path(LocationID, Metric))
  aFile.Delete
  set aFile = nothing
 End If
 Set f=fs.CreateTextFile(path(LocationID, Metric), true, false)
 f.Write HtmlResult
 f.Close
 Set f=Nothing
 Set fs=Nothing
End Function
