Dim DefaultUnit
MaxHourNum = 12		  ' the number of hours of outlook data to retreive with each refresh (24 is absolute max)
DefaultUnit = "English"   ' change this to metric if you plan on using mostly metric units 
			  ' (so you don't have to double up on your cached files)


Set xmlhandle = CreateObject("Microsoft.XMLDOM")
xmlhandle.async = False

Function CityName(LocationID)
 CityName = twodeep(LocationID, DefaultUnit, "loc", 1, "dnam")
End Function

Function HourName(LocationID, Hour)
 HourName = twodeepalt(LocationID, DefaultUnit, "hour", Hour, "c")
 If HourName > 12 Then
  HourName = (HourName - 12)  & " PM"
 Else
  If HourName = 12 Then 
   HourName = HourName & " PM"
  Else 
   If HourName = 0 Then
    HourName = "12 AM"
   Else
    HourName = HourName & " AM"
   End If
  End If
 End If
End Function

Function HourlyTemp(LocationID, Hour, UnitType, ShowDegreeSymbol)
 HourlyTemp = TheTemp(LocationID, "hour", Hour, UnitType, "tmp", ShowDegreeSymbol)
End Function

Function HourlyTempFeelsLike(LocationID, Hour, UnitType)
 HourlyTempFeelsLike = TheTemp(LocationID, "hour", Hour, UnitType, "flik", ShowDegreeSymbol)
End Function

Function HourlyCondition(LocationID, Hour)
 HourlyCondition = twodeep(LocationID, DefaultUnit, "hour", Hour, "t")
End Function

Function HourlyHumidity(LocationID, Hour)
 HourlyHumidity = twodeep(LocationID, DefaultUnit, "hour", Hour, "hmid")
End Function

Function HourlyPrecipitation(LocationID, Hour)
 HourlyPrecipitation = twodeep(LocationID, DefaultUnit, "hour", Hour, "ppcp")
End Function

Function HourlyDewPoint(LocationID, Hour, UnitType)
 HourlyDewPoint = twodeep(LocationID, UnitType, "hour", Hour, "dewp")
End Function

Function HourlyWindSpeed(LocationID, Hour, UnitType)
 HourlyWindSpeed = threedeep(LocationID, UnitType, "hour", Hour, "wind", "s")
End Function

Function HourlyWindDirection(LocationID, Hour)
 HourlyWindDirection = threedeep(LocationID, DefaultUnit, "hour", Hour, "wind", "t")
End Function

Function HourlyWindDegree(LocationID, Hour)
 HourlyWindDegree = threedeep(LocationID, DefaultUnit, "hour", Hour, "wind", "d")
End Function

Function HourlySymbol(LocationID, Hour, PathToPNGs, ImageSize)
 If ImageSize <> "small" AND ImageSize <> "medium" AND ImageSize <> "large" Then
  HourlySymbol = "Set ImageSize to any of these values: small, medium, large"
  Exit Function
 End If
 HourlySymbol = FixUserPath(PathToPNGs) & ImageSize & twodeep(LocationID, DefaultUnit, "hour", Hour, "icon") & ".png"
End Function

Private Function TheSymbol(LocationID, DayNum, PathToPNGs, ImageSize, DayOrNight)
 If ImageSize <> "small" AND ImageSize <> "medium" AND ImageSize <> "large" Then
  TheSymbol = "Set ImageSize to any of these values: small, medium, large"
  Exit Function
 End If
 TheSymbol = FixUserPath(PathToPNGs) & ImageSize & threedeep(LocationID, DefaultUnit, "day", DayNum, "part", DayOrNight, "icon") & ".png"
End Function

Private Function UpdateTime(LocationID)
 UpdateTime = twodeep(LocationID, DefaultUnit, "dayf", 1, "lsup")
 If UpdateTime = "DayNum ERROR" Then Exit Function End If
 theday = Pattern(UpdateTime, "(.*?)/(.*?)/(.*?) (.*?) (.*?) (.*?)", 1)+0
 themonth = Pattern(UpdateTime, "(.*?)/(.*?)/(.*?) (.*?) (.*?) (.*?)", 0)+0
 therealday = thedate(1)+0
 If theday <> therealday Then
  UpdateTime = themonth & "/" & theday
 Else
  UpdateTime = Pattern(UpdateTime, "(.*?) (.*?) (.*?) (.*?)", 1) & " " & Pattern(UpdateTime, "(.*?) (.*?) (.*?) (.*?)", 2)
 End If
End Function

Private Function TheTemp(LocationID, TempType, ItemNum, UnitType, ItemName, ShowDegreeSymbol)
 TheTemp = twodeep(LocationID, UnitType, TempType, ItemNum, ItemName)
 If TheTemp = "N/A" Then
  DegreeSymbol = ""
 Else
  DegreeSymbol = ""
 End If
 TheTemp = TheTemp & DegreeSymbol
 If ShowDegreeSymbol = "0" Then
  TheTemp = Replace(TheTemp, "", "")
 End If
End Function

Private Function VerifyDay(DayNum)
 If DayNum > 10 Then
  VerifyDay = "DayNum ERROR"
  Exit Function
 End If

 If DayNum > MaxDayNum Then
  VerifyDay = "DayNum ERROR"
  Exit Function
 End If

 If DayNum < 1 Then
  VerifyDay = "DayNum ERROR"
  Exit Function
 End If

 VerifyDay = "OK"
End Function

Private Function FixUserPath(ThePath)
 If(mid(ThePath, len(ThePath), len(ThePath)+1) <> "\") Then
  FixUserPath = ThePath & "\"
 Else
  FixUserPath = ThePath
 End If
End Function

Private Function threedeep(LocationID, UnitType, First, DayNum, Second, Third)
 xmlhandle.LoadXML(GetText(LocationID, UnitType))
 threedeep = xmlhandle.getelementsbytagname(First).item(DayNum-1).getelementsbytagname(Second).item(0).getelementsbytagname(Third).item(0).text
End Function

Private Function twodeepalt(LocationID, UnitType, First, ItemNum, AttName)
 xmlhandle.LoadXML(GetText(LocationID, UnitType))
 twodeepalt = xmlhandle.getelementsbytagname(First).item(ItemNum-1).getattribute(AttName)
End Function

Private Function twodeep(LocationID, UnitType, First, DayNum, Second)
 xmlhandle.LoadXML(GetText(LocationID, UnitType))
 twodeep = xmlhandle.getelementsbytagname(First).item(DayNum-1).getelementsbytagname(Second).item(0).text
End Function

Private Function TheDate(which)
 TheDate = Now()
 TheDate = Pattern(TheDate, "(.*?)/(.*?)/(.*?) (.*?)", which)
 TheDate = TheDate+0
End Function

Private Function shortendayname(dayname)
 If dayname = "Monday" Then shortendayname = "Mon" End If
 If dayname = "Tuesday" Then shortendayname = "Tue" End If
 If dayname = "Wednesday" Then shortendayname = "Wed" End If
 If dayname = "Thursday" Then shortendayname = "Thu" End If
 If dayname = "Friday" Then shortendayname = "Fri" End If
 If dayname = "Saturday" Then shortendayname = "Sat" End If
 If dayname = "Sunday" Then shortendayname = "Sun" End If
End Function

Private Function path(LocationID, UnitType)
 path = GetTempPath & LocationID & "_" & SetUnit(UnitType) & "_" & MaxHourNum & "_Hours" & ".tmp"
End Function

Private Function GetTempPath
 set fso=CreateObject("Scripting.FileSystemObject")
 GetTempPath = fso.GetSpecialFolder(2) & "\weather.com.hourly\" 
 if not fso.FolderExists(GetTempPath) then 
  fso.CreateFolder(GetTempPath)
 End if
End Function

Private Function TimeDiff(LocationID, UnitType)
 dim fs,f,diff
 file = path(LocationID, UnitType)
 set fs=CreateObject("Scripting.FileSystemObject")
 if fs.fileexists(file) then
  set f=fs.GetFile(file)
  diff = datediff( "n", f.DateLastModified, now())
 else
  diff = -1
 end if
 set f=nothing
 set fs=nothing
 TimeDiff = diff
End Function

Private Function Pattern(TheString, ThePattern, MatchNum)
 Set regEx = New RegExp 
 regEx.Global = True
 regEx.IgnoreCase = True
 regEx.Pattern = ThePattern
 Set Matches = regEx.Execute(TheString) 
 For Each Match in Matches 
  result = trim(Match.SubMatches(MatchNum)) 
 Next 
 Pattern = result
End Function

Private Function RandomNum
 Randomize Timer
 RandomNum = Int(Rnd * 1000)
End Function

Private Function MaybeUnit(TheUnit, Maybe)
 If Maybe = 1 Then
  MaybeUnit = TheUnit
 Else
  MaybeUnit = ""
 End If
End Function

Private Function SetUnit(UnitType)
 If UnitType="Metric" Then
  SetUnit = "m"
 Else
  SetUnit = "s"
 End If
End Function

Private Function TempUnit(LocationID, UnitType)
 TempUnit = twodeep(LocationID, UnitType, "head", 1, "ut")
End Function

Private Function SpeedUnit(LocationID, UnitType)
 SpeedUnit = " " & twodeep(LocationID, UnitType, "head", 1, "us")
End Function

Private Function GetText(LocationID, UnitType)
 If TimeDiff(LocationID, UnitType) < 0 Then
  GetText = Writefile(LocationID, UnitType)       'file doesn't exist so fetch it
 Else
  If TimeDiff(LocationID, UnitType) > 31 Then        'see if it needs refreshing
   GetText = Writefile(LocationID, UnitType) 'refresh it
  End If
 End If
 GetText = GetFileContents(LocationID, UnitType)           'read it's contents

End Function

Private Function GetFileContents(LocationID, UnitType)
 Set file_obj = CreateObject ("Scripting.FileSystemObject")
 Set file_path = file_obj.GetFile(path(LocationID, UnitType)) ' Creates the connection to the file
 set file = file_path.OpenAsTextStream (1, -2) ' Opens the file for reading
 GetFileContents = file.readall
 File.Close ' Closes the file
 Set file_path = nothing ' Resets variable
 Set file_obj = nothing ' Resets variable
End Function

Private Function Writefile(LocationID, UnitType)
 GetURL = "http://xoap.weather.com/weather/local/" & LocationID & "?hbhf=" & MaxHourNum & "&unit=" & SetUnit(UnitType) & "&" & RandomNum
 Dim Http
 Set Http = CreateObject("Microsoft.XMLhttp")
 Http.Open "GET",GetURL,False
 Http.Send
 HtmlResult = Http.ResponseText
 Set Http = Nothing
 Set fs=CreateObject("Scripting.FileSystemObject")
 If (fs.FileExists(path(LocationID, UnitType))) Then
  Set aFile = fs.GetFile(path(LocationID, UnitType))
  aFile.Delete
  set aFile = nothing
 End If
 Set f=fs.CreateTextFile(path(LocationID, UnitType), true, false)
 f.Write HtmlResult
 f.Close
 Set f=Nothing
 Set fs=Nothing
End Function