Dim DefaultUnit
MaxDayNum = 5             ' the number of days of outlook data to retreive with each refresh (10 is absolute max)
DefaultUnit = "English"   ' change this to metric if you plan on using mostly metric units 
			  ' (so you don't have to double up on your cached files)


Set xmlhandle = CreateObject("Microsoft.XMLDOM")
xmlhandle.async = False

Function CityName(LocationID)
 CityName = twodeep(LocationID, DefaultUnit, "loc", 1, "dnam")
End Function

Function Latitude(LocationID)
 Latitude = twodeep(LocationID, DefaultUnit, "loc", 1, "lat")
End Function

Function Longitude(LocationID)
 Longitude = twodeep(LocationID, DefaultUnit, "loc", 1, "lon")
End Function

Function LocalTime(LocationID)
 LocalTime = twodeep(LocationID, DefaultUnit, "loc", 1, "tm")
End Function

Function Sunrise(LocationID, DayNum)
 Sunrise = twodeep(LocationID, DefaultUnit, "day", DayNum, "sunr")
End Function

Function Sunset(LocationID, DayNum)
 Sunset = twodeep(LocationID, DefaultUnit, "day", DayNum, "suns")
End Function

Function DayName(LocationID, DayNum, ShowDate)
 DayName = VerifyDay(DayNum+0)
 If DayName = "DayNum ERROR" Then Exit Function End If
 xmlhandle.LoadXML(GetText(LocationID, DefaultUnit))
 Set theday = xmlhandle.getelementsbytagname("day").item(DayNum-1)
 If pattern(LocalTime(LocationID), "(.*?):(.*?) (.*?)", 0)+0 > 1 AND pattern(LocalTime(LocationID), "(.*?):(.*?) (.*)", 2) = "PM" Then
  DayName = "Tonight"
 Else
  DayName = "Today"
 End If
 If DayNum > 1 Then DayName = shortendayname(theday.getattribute("t")) End If
 If Showdate = "1" Then 
  DayName = DayName & " (" & theday.getattribute("dt") & ")"
 End If
End Function

Function DayTemp(LocationID, DayNum, UnitType)
 DayTemp = TheTemp(LocationID, DayNum, UnitType, "hi") 
End Function

Function NightTemp(LocationID, DayNum, UnitType)
 NightTemp = TheTemp(LocationID, DayNum, UnitType, "low") 
End Function

Function DayCondition(LocationID, DayNum)
 DayCondition = threedeep(LocationID, DefaultUnit, "day", DayNum, "part", 0, "t")
End Function

Function NightCondition(LocationID, DayNum)
 NightCondition = threedeep(LocationID, DefaultUnit, "day", DayNum, "part", 1, "t")
End Function

Function DayPrecipitation(LocationID, DayNum)
 DayPrecipitation = threedeep(LocationID, DefaultUnit, "day", DayNum, "part", 0, "ppcp")
End Function

Function NightPrecipitation(LocationID, DayNum)
 NightPrecipitation = threedeep(LocationID, DefaultUnit, "day", DayNum, "part", 1, "ppcp")
End Function

Function TodayPrecip(LocationID)
 If pattern(LocalTime(LocationID), "(.*?):(.*?) (.*?)", 0)+0 > 1 AND pattern(LocalTime(LocationID), "(.*?):(.*?) (.*)", 2) = "PM" Then
  DayOrNight = 1
 Else
  DayOrNight = 0
 End If
 TodayPrecip = threedeep(LocationID, DefaultUnit, "day", 1, "part", DayOrNight, "ppcp")
End Function

Function DayHumidity(LocationID, DayNum)
 DayHumidity = threedeep(LocationID, DefaultUnit, "day", DayNum, "part", 0, "hmid")
End Function

Function NightHumidity(LocationID, DayNum)
 NightHumidity = threedeep(LocationID, DefaultUnit, "day", DayNum, "part", 1, "hmid")
End Function

Function DaySymbol(LocationID, DayNum, PathToPNGs, ImageSize)
 DaySymbol = TheSymbol(LocationID, DayNum, PathToPNGs, ImageSize, 0)
End Function

Function NightSymbol(LocationID, DayNum, PathToPNGs, ImageSize)
 NightSymbol = TheSymbol(LocationID, DayNum, PathToPNGs, ImageSize, 1)
End Function

Private Function TheSymbol(LocationID, DayNum, PathToPNGs, ImageSize, DayOrNight)
 If ImageSize <> "small" AND ImageSize <> "medium" AND ImageSize <> "large" Then
  TheSymbol = "Set ImageSize to any of these values: small, medium, large"
  Exit Function
 End If
 TheSymbol = FixUserPath(PathToPNGs) & ImageSize & threedeep(LocationID, DefaultUnit, "day", DayNum, "part", DayOrNight, "icon") & ".png"
End Function

Function DayWind(LocationID, DayNum, UnitType)
 DayWind = TheWind(LocationID, DayNum, UnitType, DayOrNight, 1, "")
End Function

Function NightWind(LocationID, DayNum, UnitType)
 NightWind = TheWind(LocationID, DayNum, UnitType, DayOrNight, 1, "")
End Function

Function DayWindMetersPerSecond(LocationID, DayNum)
 DayWindMetersPerSecond = TheWind(LocationID, DayNum, "Metric", DayOrNight, 3.6, "m/s")
End Function

Function NightWindMetersPerSecond(LocationID, DayNum)
 NightWindMetersPerSecond = TheWind(LocationID, DayNum, "Metric", DayOrNight, 3.6, "m/s")
End Function

Function UpdateTime(LocationID, ShowDate, ShowTime)
 UpdateTime = twodeep(LocationID, DefaultUnit, "dayf", 1, "lsup")
 If UpdateTime = "DayNum ERROR" Then Exit Function End If
 TheDates = Pattern(UpdateTime, "(.*?)/(.*?)/(.*?) (.*?) (.*?) (.*?)", 0) & "/" & Pattern(UpdateTime, "(.*?)/(.*?)/(.*?) (.*?) (.*?) (.*?)", 1) 
 TheTime = Pattern(UpdateTime, "(.*?) (.*?) (.*?) (.*?)", 1) & " " & Pattern(UpdateTime, "(.*?) (.*?) (.*?) (.*?)", 2)
 If ShowDate = "0" Then 
  TheDates = ""
 End If
 If ShowTime = "0" Then
  TheTime = ""
 End If
 If TheDates <> "0" AND TheTime <> "0" Then
  TheDates = TheDates & " "
 End If
 UpdateTime = TheDates & TheTime
End Function

Private Function TheWind(LocationID, DayNum, UnitType, DayOrNight, Special, SpecialUnit)
 TheWind = fourdeep(LocationID, UnitType, "day", DayNum, "part", DayOrNight+0, "wind", "s")
 If TheWind = "DayNum ERROR" Then Exit Function Else TheWind = Round(TheWind / Special, 0) End If
 thegust = fourdeep(LocationID, UnitType, "day", DayNum, "part", DayOrNight+0, "wind", "gust")
 thedirection = fourdeep(LocationID, UnitType, "day", DayNum, "part", DayOrNight+0, "wind", "t")
 if thegust = "N/A" then thegust = "" else thegust = " to " & round(thegust / special, 0) end if
 If Special > 1 Then
  TheWind = thedirection & " @ " & TheWind & thegust & " " & SpecialUnit
 Else
  TheWind = thedirection & " @ " & TheWind & thegust & SpeedUnit(LocationID, UnitType)
 End If
End Function

Private Function TheTemp(LocationID, DayNum, UnitType, HiOrLow)
 TheTemp = twodeep(LocationID, UnitType, "day", DayNum, HiOrLow)
 If TheTemp = "N/A" Then
  DegreeSymbol = ""
 Else
  DegreeSymbol = ""
 End If
 TheTemp = TheTemp & DegreeSymbol
End Function

Private Function VerifyDay(DayNum)
 If DayNum > 10 Then
  VerifyDay = "DayNum ERROR"
  Exit Function
 End If

 If DayNum > MaxDayNum Then
  VerifyDay = "DayNum ERROR"
  Exit Function
 End If

 If DayNum < 1 Then
  VerifyDay = "DayNum ERROR"
  Exit Function
 End If

 VerifyDay = "OK"
End Function

Private Function FixUserPath(ThePath)
 If(mid(ThePath, len(ThePath), len(ThePath)+1) <> "\") Then
  FixUserPath = ThePath & "\"
 Else
  FixUserPath = ThePath
 End If
End Function

Private Function fourdeep(LocationID, UnitType, First, DayNum, Second, PartNum, Third, Fourth)
 fourdeep = VerifyDay(DayNum+0)
 If fourdeep <> "OK" Then Exit Function End If
 xmlhandle.LoadXML(GetText(LocationID, UnitType))
 fourdeep = xmlhandle.getelementsbytagname(First).item(DayNum-1).getelementsbytagname(Second).item(PartNum).getelementsbytagname(Third).item(0).getelementsbytagname(Fourth).item(0).text
End Function

Private Function threedeep(LocationID, UnitType, First, DayNum, Second, PartNum, Third)
 threedeep = VerifyDay(DayNum+0)
 If threedeep <> "OK" Then Exit Function End If
 xmlhandle.LoadXML(GetText(LocationID, UnitType))
 threedeep = xmlhandle.getelementsbytagname(First).item(DayNum-1).getelementsbytagname(Second).item(PartNum).getelementsbytagname(Third).item(0).text
End Function

Private Function twodeep(LocationID, UnitType, First, DayNum, Second)
 twodeep = VerifyDay(DayNum+0)
 If twodeep <> "OK" Then Exit Function End If
 xmlhandle.LoadXML(GetText(LocationID, UnitType))
 twodeep = xmlhandle.getelementsbytagname(First).item(DayNum-1).getelementsbytagname(Second).item(0).text
End Function

Private Function TheDate(which)
 TheDate = Now()
 TheDate = Pattern(TheDate, "(.*?)/(.*?)/(.*?) (.*?)", which)
 TheDate = TheDate+0
End Function

Private Function shortendayname(dayname)
 If dayname = "Monday" Then shortendayname = "Mon" End If
 If dayname = "Tuesday" Then shortendayname = "Tue" End If
 If dayname = "Wednesday" Then shortendayname = "Wed" End If
 If dayname = "Thursday" Then shortendayname = "Thu" End If
 If dayname = "Friday" Then shortendayname = "Fri" End If
 If dayname = "Saturday" Then shortendayname = "Sat" End If
 If dayname = "Sunday" Then shortendayname = "Sun" End If
End Function

Private Function path(LocationID, UnitType)
 path = GetTempPath & LocationID & "_" & SetUnit(UnitType) & "_" & MaxDayNum & "_Days" & ".tmp"
End Function

Private Function GetTempPath
 set fso=CreateObject("Scripting.FileSystemObject")
 GetTempPath = fso.GetSpecialFolder(2) & "\weather.com.outlook\" 
 if not fso.FolderExists(GetTempPath) then 
  fso.CreateFolder(GetTempPath)
 End if
End Function

Private Function TimeDiff(LocationID, UnitType)
 dim fs,f,diff
 file = path(LocationID, UnitType)
 set fs=CreateObject("Scripting.FileSystemObject")
 if fs.fileexists(file) then
  set f=fs.GetFile(file)
  diff = datediff( "n", f.DateLastModified, now())
 else
  diff = -1
 end if
 set f=nothing
 set fs=nothing
 TimeDiff = diff
End Function

Private Function Pattern(TheString, ThePattern, MatchNum)
 Set regEx = New RegExp 
 regEx.Global = True
 regEx.IgnoreCase = True
 regEx.Pattern = ThePattern
 Set Matches = regEx.Execute(TheString) 
 For Each Match in Matches 
  result = trim(Match.SubMatches(MatchNum)) 
 Next 
 Pattern = result
End Function

Private Function RandomNum
 Randomize Timer
 RandomNum = Int(Rnd * 1000)
End Function

Private Function MaybeUnit(TheUnit, Maybe)
 If Maybe = 1 Then
  MaybeUnit = TheUnit
 Else
  MaybeUnit = ""
 End If
End Function

Private Function SetUnit(UnitType)
 If UnitType="Metric" Then
  SetUnit = "m"
 Else
  SetUnit = "s"
 End If
End Function

Private Function TempUnit(LocationID, UnitType)
 TempUnit = twodeep(LocationID, UnitType, "head", 1, "ut")
End Function

Private Function SpeedUnit(LocationID, UnitType)
 SpeedUnit = " " & twodeep(LocationID, UnitType, "head", 1, "us")
End Function

Private Function GetText(LocationID, UnitType)
 If TimeDiff(LocationID, UnitType) < 0 Then
  GetText = Writefile(LocationID, UnitType)       'file doesn't exist so fetch it
 Else
  If TimeDiff(LocationID, UnitType) > 125 Then        'see if it needs refreshing
   GetText = Writefile(LocationID, UnitType) 'refresh it
  End If
 End If
 GetText = GetFileContents(LocationID, UnitType)           'read it's contents

End Function

Private Function GetFileContents(LocationID, UnitType)
 Set file_obj = CreateObject ("Scripting.FileSystemObject")
 Set file_path = file_obj.GetFile(path(LocationID, UnitType)) ' Creates the connection to the file
 set file = file_path.OpenAsTextStream (1, -2) ' Opens the file for reading
 GetFileContents = file.readall
 File.Close ' Closes the file
 Set file_path = nothing ' Resets variable
 Set file_obj = nothing ' Resets variable
End Function

Private Function Writefile(LocationID, UnitType)
 GetURL = "http://xoap.weather.com/weather/local/" & LocationID & "?dayf=" & MaxDayNum & "&unit=" & SetUnit(UnitType) & "&" & RandomNum
 Dim Http
 Set Http = CreateObject("Microsoft.XMLhttp")
 Http.Open "GET",GetURL,False
 Http.Send
 HtmlResult = Http.ResponseText
 Set Http = Nothing
 Set fs=CreateObject("Scripting.FileSystemObject")
 If (fs.FileExists(path(LocationID, UnitType))) Then
  Set aFile = fs.GetFile(path(LocationID, UnitType))
  aFile.Delete
  set aFile = nothing
 End If
 Set f=fs.CreateTextFile(path(LocationID, UnitType), true, false)
 f.Write HtmlResult
 f.Close
 Set f=Nothing
 Set fs=Nothing
End Function